/*
 * LocateView.cpp
 *
 * Written by Matt Pauker
 *
 * Last modified: 11/9/96
 */

#include "LocateView.h"

LocateView::LocateView(BRect frame) :	BView(frame, "containerView", NULL, B_PULSE_NEEDED)
{
	ResetCoords();		// Initialize old coords
	
	// Create string views for the x and y coords
	xView = new BStringView(BRect(3, 3, frame.right - frame.left, 15), "xView", "");
	AddChild(xView);
	yView = new BStringView(BRect(3, 18, frame.right - frame.left, 30), "yView", "");
	AddChild(yView);
}

void LocateView::Pulse()
{
	char *s = new char[16];
	BPoint mouseLoc;
	ulong x;
	
	// Get the current mouse location and convert it to screen coords
	GetMouse(&mouseLoc, &x);
	ConvertToScreen(&mouseLoc);

	// If the mouse x coord has changed, update the view
	if (mouseLoc.x != oldX)
	{
		sprintf(s, "X: %d", (int)mouseLoc.x);
		xView->SetText(s);
		oldX = mouseLoc.x;
	}
	// If the mouse y coord has changed, update the view
	if (mouseLoc.y != oldY)
	{
		sprintf(s, "Y: %d", (int)mouseLoc.y);
		yView->SetText(s);
		oldY = mouseLoc.y;
	}
}

void LocateView::ResetCoords()
// Resets oldX and oldY so the views will definitely update at the next pulse
{
	oldX = -1;
	oldY = -1;
}